close.c
close (fd)
{
}
exit.c
/* Copyright (C) 1984 by Manx Software Systems, Inc. */

int (*cls_)() = 0;

exit(code)
{
	register int fd;

	if (cls_)
		(*cls_)();
	for (fd = 0 ; fd < 10 ; fd++)
		close(fd);
	_exit(code);
}

exitu.c
_exit(n)
{
}
ioctl.c
ioctl(fd, cmd, ttp)
struct sgttyb *ttp;
{
}
isatty.c
isatty(fd)
register int fd;
{
}
lseek.c
long
lseek (fd, pos, how)
long pos;
{
}
mainu.c
_main()
{
	main();
	exit();
}
makefile
.SUFFIXES: .c .a68 .asm .r .rll
CFLAGS=

#
# make small code, small data object modules for rom (extension=.r)
#

OBJ=  rom68.r\
	open.r close.r read.r write.r lseek.r sbrk.r exit.r exitu.r\
	unlink.r ioctl.r mainu.r isatty.r rename.r stkchk.r 

.c.r:
	c68 $(CFLAGS) -o $*.r $*

.a68.r:
	as68 -o $*.r $*.a68

.asm.r:
	as68 -o $*.r $*.asm

all: $(OBJ) 
	echo done

#
# make large code, large data object modules for rom (extension=.rll)
#

OLL=  rom68.rll\
	open.rll close.rll read.rll write.rll lseek.rll sbrk.rll exit.rll exitu.rll\
	unlink.rll ioctl.rll mainu.rll isatty.rll rename.rll stkchk.rll 

.c.rll:
	c68 +c +d $(CFLAGS) -o $*.rll $*

.a68.rll:
	as68 -c -d -o $*.rll $*.a68

.asm.rll:
	as68 -c -d -o $*.rll $*.asm

big: $(OLL) 
	echo done

#
# build rom68.arc
#

SRC=  rom68.a68\
	open.c close.c read.c write.c lseek.c sbrk.c exit.c exitu.c\
	unlink.c ioctl.c mainu.c isatty.c rename.c stkchk.c

arc: $(SRC)
	mkarcv rom68.arc <rom68.bld
open.c
#include	<fcntl.h>

creat(name, mode)
char *name;
{
	return open(name, O_WRONLY|O_TRUNC|O_CREAT, mode);
}

open(uname, flags, mode)
char *uname;
{
}

read.c
read (fd, buf, cnt)
register int fd, cnt;
register char *buf;
{
}
rename.c
rename(o, n)
register char *o, *n;
{
}

rom68.a68
; Copyright (C) 1986 by Manx Software Systems

; Start-up routine for 68k rom based development.

; These masks enable and disable interrupts when running in 
; supervisor mode.  The $2000 part of the mask indicates 
; supervisor mode.

MaskInts	equ $2700		; mask to disable interrupts
EnableInts	equ $2000		; mask to enable interrupts

; DATA SEGMENT
		dseg
		public	__mbot,__mtop,__mcur	;*jd 15 Dec 86
		public	__stkbase				;*jd 8/20/87
		public	_errno

HEAPSIZE	equ	$800	; size of heap space		*jd 15 Dec 86
__mbot	ds.l	1		; ptr to bottom of heap		*jd 15 Dec 86
__mtop	ds.l	1		; ptr to top of heap		*jd 15 Dec 86
__mcur	ds.l	1		; ptr to top of allocated heap space	*jd 15 Dec 86
__stkbase	ds.l	1	; ptr to bottom of stack area		*jd 8/20/87 
_errno	ds.w	1		; place to store error numbers

		public __H1_org,__H1_end	;*jd 27 Oct 86
		public __H2_org,__H2_end	;*jd 27 Oct 86
		public __H0_org,__H0_end	;*jd 27 Oct 86

; CODE SEGMENT

; When the 68k processor is reset or powered up, it fetches the values
; at offsets 0 and 4, which contain the address of the first instruction 
; to execute and the initial stack pointer value respectively.
; The space up to $400 is reserved for the interrupt vector.  This
; vector is not initilialized!

		cseg

		public	_Storg_,STKSIZ		
		public	.begin
		entry	.begin				;*jd 6 aug 87
		public	_main

		dc.l	_Storg_				; initial stack pointer value
		dc.l	.begin				; address of first instruction
		ds.b	$3f8				; reserve space for interrupt vectors

.begin:
		move.w	#MaskInts,sr		; mask interrupts (supervisor mode)
;
; Assume program uses small code &/or small data 
; and that it uses A5 to access jmptabs and data
; ...if program uses large code and large data, 
;    and you want to use A5 for other purposes (eg, register variable),
;    delete the next line of code
; ...if it uses a different address register, change the next line
		move.l	#__H1_org+32766,a5	;*jd 17 Nov 86

; Calculate length of initialized data segment
		move.l	#__H1_end,d0		;*jd 27 Oct 86
		sub.l	#__H1_org,d0		;*jd 27 Oct 86
		beq		.1end				; skip if no initialized data
		lsr.l	#1,d0				; divide length by 2 and copy words

; Get addresses of initialized data segment and destination
		move.l	#__H0_end,a0			; data is at end of code segment
		move.l	#__H1_org,a1			; data segment destination address

; Copy initialized data segment from _Cend_ to _Dorg_
.1
		move.w	(a0)+,(a1)+
		dbra	d0,.1
.1end

; Calculate length of BSS segment and initialize address register
		move.l	#__H2_end,d0		;*jd 27 Oct 86
		sub.l	#__H2_org,d0		;*jd 27 Oct 86
		beq		.2end				; skip if no BSS segment
		lsr.l	#1,d0				; divide length by 2 and clear words
		move.l	#__H2_org,a0		; BSS base address

; Initialize BSS segment to 0
.2
		clr.w	(a0)+
		dbra	d0,.2
.2end

; Initialize heap ptrs
		move.l	#_Storg_,d0
		add.l	#3,d0			; align heap on 32-bit boundary *jd 15 Dec 86
		and.l	#-8,d0			; *jd 15 Dec 86
		move.l	d0,__mbot		; *jd 15 Dec 86
		move.l	d0,__mcur		; *jd 15 Dec 86
		add.l	#HEAPSIZE,d0	; *jd 15 Dec 86
		move.l	d0,__mtop		; *jd 15 Dec 86

; Initialize stack pointers
		move.l	#_Storg_,d0
		sub.l	#STKSIZ,d0			;*jd10/27/86
		move.l	d0,__stkbase		; bottom of stack
		move.l	d0,a0				;for stack overflow checking *jd 8/14/87
		move.l	#$4d414e58,4(a0)	;"MANX" at base of stack area

; Enable interrupts and branch to main routine
		move.w	#EnableInts,sr		; enable interrupts (supervisor mode)
		jmp		_main				; *jd 10/28/86
		end
rom68old.a68
; Copyright (C) 1986 by Manx Software Systems

; Start-up routine for 68k rom based development.

; These masks enable and disable interrupts when running in 
; supervisor mode.  The $2000 part of the mask indicates 
; supervisor mode.

MaskInts	equ $2700		; mask to disable interrupts
EnableInts	equ $2000		; mask to enable interrupts

; DATA SEGMENT
		dseg
		public	__mbot,__mtop,__mcur	;*jd 15 Dec 86
		public	__sbot
		public	_errno

HEAPSIZE	equ	$800	; size of heap space		*jd 15 Dec 86
__mbot	ds.l	1		; ptr to bottom of heap		*jd 15 Dec 86
__mtop	ds.l	1		; ptr to top of heap		*jd 15 Dec 86
__mcur	ds.l	1		; ptr to top of allocated heap space	*jd 15 Dec 86
__sbot	ds.l	1		; ptr to bottom of stack area		*jd 16 Dec 86
_errno	ds.w	1		; place to store error numbers

		public __H1_org,__H1_end	;*jd 27 Oct 86
		public __H2_org,__H2_end	;*jd 27 Oct 86
		public __H0_org,__H0_end	;*jd 27 Oct 86

; CODE SEGMENT

; When the 68k processor is reset or powered up, it fetches the values
; at offsets 0 and 4, which contain the address of the first instruction 
; to execute and the initial stack pointer value respectively.
; The space up to $400 is reserved for the interrupt vector.  This
; vector is not initilialized!

		cseg

		public	_Storg_,STKSIZ		
		public	.begin
		public	_main

		dc.l	_Storg_				; initial stack pointer value
		dc.l	.begin				; address of first instruction
		ds.b	$3f8				; reserve space for interrupt vectors

.begin:
		move.w	#MaskInts,sr		; mask interrupts (supervisor mode)
;
; Assume program uses small code &/or small data 
; and that it uses A5 to access jmptabs and data
; ...if program uses large code and large data, 
;    and you want to use A5 for other purposes (eg, register variable),
;    delete the next line of code
; ...if it uses a different address register, change the next line
		move.l	#__H1_org+32766,a5	;*jd 17 Nov 86

; Calculate length of initialized data segment
		move.l	#__H1_end,d0		;*jd 27 Oct 86
		sub.l	#__H1_org,d0		;*jd 27 Oct 86
		beq		.1end				; skip if no initialized data
		lsr.l	#1,d0				; divide length by 2 and copy words

; Get addresses of initialized data segment and destination
		move.l	#__H0_end,a0			; data is at end of code segment
		move.l	#__H1_org,a1			; data segment destination address

; Copy initialized data segment from _Cend_ to _Dorg_
.1
		move.w	(a0)+,(a1)+
		dbra	d0,.1
.1end

; Calculate length of BSS segment and initialize address register
		move.l	#__H2_end,d0		;*jd 27 Oct 86
		sub.l	#__H2_org,d0		;*jd 27 Oct 86
		beq		.2end				; skip if no BSS segment
		lsr.l	#1,d0				; divide length by 2 and clear words
		move.l	#__H2_org,a0		; BSS base address

; Initialize BSS segment to 0
.2
		clr.w	(a0)+
		dbra	d0,.2
.2end

; Initialize heap ptrs
		move.l	#_Storg_,d0
		add.l	#3,d0			; align heap on 32-bit boundary *jd 15 Dec 86
		and.l	#-8,d0			; *jd 15 Dec 86
		move.l	d0,__mbot		; *jd 15 Dec 86
		move.l	d0,__mcur		; *jd 15 Dec 86
		add.l	#HEAPSIZE,d0	; *jd 15 Dec 86
		move.l	d0,__mtop		; *jd 15 Dec 86

; Initialize stack pointers
		move.l	#_Storg_,d0
		sub.l	#STKSIZ,d0		;*jd10/27/86
		move.l	d0,__sbot			; bottom of stack

; Enable interrupts and branch to main routine
		move.w	#EnableInts,sr		; enable interrupts (supervisor mode)
		jmp		_main				; *jd 10/28/86
		end
sbrk.c
#include <errno.h>

extern char *_mbot, *_mtop, *_mcur;

char *
brk(ptr)
register char *ptr;
{
	ptr = (char *)(((long)ptr+3) & ~3);	/* set ptr on 32-bit boundary */
	if (ptr >= _mbot && ptr < _mtop){
		_mcur = ptr;
		return 0;
	} else {
		errno=ENOMEM;
		return (char *) -1;
	}
}

char *
sbrk(size)
register unsigned size;
{
	register char *ptr = _mcur;
	if (brk(_mcur+size) != (char *)-1)
		return ptr;
	else 
		return (char *) -1;
}

stkchk.c
#asm
;:ts=8
; Copyright (C) 1986,1987 by Manx Software Systems, Inc.
;
	dseg
	public	__stkbase,_Storg_
	cseg
	public	__stkover
	public	__stkchk
__stkchk:
	move.l	__stkbase,a0
	cmp.l	a7,a0
	bge	oflow
	cmp.l	#'MANX',4(a0)
	bne	oflow
	rts
oflow
	move.l	#_Storg_,d0	;reinitialize SP near the top of stack area.
	sub.l	#16,d0		;you will probably need to customize this code
	move.l	d0,a7		
	jmp	__stkover
#endasm
/*
 *	_stkover is called when __stkchk detects an
 *	overrun of the stack area.
 *  	It must be customized for use on each ROM system
 */
_stkover()
{
	write(1, "Stack overflow!!\n", 17);
	_exit(100);
}
unlink.c
unlink(nam)
register char *nam;
{
}
write.c
write (fd, buf, cnt)
int fd;
register int cnt;
register char *buf;
{
}
writecpm.c
write (fd, buf, cnt)
int fd;
register int cnt;
register char *buf;
{
	register int i;

	for(i=0;i<cnt;i++)
		bdos(2,buf[i]);
	return cnt;
}
